jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Alan Leung | 0afa07a | 2017-10-03 16:56:30 -0700 | [diff] [blame] | 48 | export USE_D8="false" |
Colin Cross | e0ef0a8 | 2017-07-27 21:29:18 +0000 | [diff] [blame] | 49 | export USE_JACK="false" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 50 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 51 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 52 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 53 | # If dx was not set by the environment variable, assume it is in the path. |
| 54 | if [ -z "$DX" ]; then |
| 55 | export DX="dx" |
| 56 | fi |
| 57 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 58 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 59 | if [ -z "$JASMIN" ]; then |
| 60 | export JASMIN="jasmin" |
| 61 | fi |
| 62 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 63 | # If smali was not set by the environment variable, assume it is in the path. |
| 64 | if [ -z "$SMALI" ]; then |
| 65 | export SMALI="smali" |
| 66 | fi |
| 67 | |
| 68 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 69 | if [ -z "$DXMERGER" ]; then |
| 70 | export DXMERGER="dexmerger" |
| 71 | fi |
| 72 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 73 | # If jack was not set by the environment variable, assume it is in the path. |
| 74 | if [ -z "$JACK" ]; then |
| 75 | export JACK="jack" |
| 76 | fi |
| 77 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 78 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 79 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 80 | export ANDROID_BUILD_TOP=$oldwd |
| 81 | fi |
| 82 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 83 | # ANDROID_HOST_OUT is not set in a build environment. |
| 84 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | f325e01 | 2017-03-03 12:35:30 -0800 | [diff] [blame] | 85 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 86 | fi |
| 87 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 88 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 89 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 90 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | fi |
| 92 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 93 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 94 | |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 95 | # Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false. |
Igor Murashkin | d323277 | 2017-06-22 14:54:13 -0700 | [diff] [blame] | 96 | if [ -z "$DESUGAR" ]; then |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 97 | export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh" |
| 98 | fi |
| 99 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 100 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 101 | if [ -z "$ZIPALIGN" ]; then |
| 102 | if which zipalign >/dev/null; then |
| 103 | ZIPALIGN="zipalign"; |
| 104 | else |
| 105 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 106 | # once it doesn't depend on libandroidfw (b/35246701) |
| 107 | case "$OSTYPE" in |
| 108 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 109 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 110 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 111 | esac |
| 112 | fi |
| 113 | fi |
| 114 | export ZIPALIGN |
| 115 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 116 | info="info.txt" |
| 117 | build="build" |
| 118 | run="run" |
| 119 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 120 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 121 | output="output.txt" |
| 122 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 123 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 124 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 125 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 126 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 127 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 128 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 129 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 130 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 131 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 132 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 133 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 134 | dev_mode="no" |
| 135 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 136 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 137 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 138 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 139 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 140 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 141 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 142 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 143 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 144 | basic_verify="false" |
| 145 | gc_verify="false" |
| 146 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 147 | jvmti_trace_stress="false" |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 148 | jvmti_field_stress="false" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 149 | jvmti_step_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 150 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 151 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 152 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 153 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 154 | have_dex2oat="yes" |
| 155 | have_patchoat="yes" |
| 156 | have_image="yes" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 157 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 158 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 159 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 160 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 161 | # By default we will use optimizing. |
| 162 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 163 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 164 | |
| 165 | while true; do |
| 166 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 167 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 168 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 169 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 170 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 171 | elif [ "x$1" = "x--quiet" ]; then |
| 172 | quiet="yes" |
| 173 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 174 | elif [ "x$1" = "x--use-java-home" ]; then |
| 175 | if [ -n "${JAVA_HOME}" ]; then |
| 176 | export JAVA="${JAVA_HOME}/bin/java" |
| 177 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 178 | else |
| 179 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 180 | usage="yes" |
| 181 | fi |
| 182 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 183 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 184 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 185 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 186 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 187 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 188 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 189 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 190 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 191 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 192 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 193 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 194 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 195 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 196 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 197 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 198 | shift |
| 199 | elif [ "x$1" = "x--dalvik" ]; then |
| 200 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 201 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 202 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 203 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 204 | have_dex2oat="no" |
| 205 | shift |
| 206 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 207 | have_patchoat="no" |
| 208 | shift |
| 209 | elif [ "x$1" = "x--no-image" ]; then |
| 210 | have_image="no" |
| 211 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 212 | elif [ "x$1" = "x--multi-image" ]; then |
| 213 | multi_image_suffix="-multi" |
| 214 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 215 | elif [ "x$1" = "x--pic-test" ]; then |
| 216 | run_args="${run_args} --pic-test" |
| 217 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 218 | elif [ "x$1" = "x--relocate" ]; then |
| 219 | relocate="yes" |
| 220 | shift |
| 221 | elif [ "x$1" = "x--no-relocate" ]; then |
| 222 | relocate="no" |
| 223 | shift |
| 224 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 225 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 226 | prebuild_mode="yes" |
| 227 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 228 | elif [ "x$1" = "x--strip-dex" ]; then |
| 229 | run_args="${run_args} --strip-dex" |
| 230 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 231 | elif [ "x$1" = "x--debuggable" ]; then |
| 232 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 233 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 234 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 235 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 236 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 237 | prebuild_mode="no" |
| 238 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 239 | elif [ "x$1" = "x--gcverify" ]; then |
| 240 | basic_verify="true" |
| 241 | gc_verify="true" |
| 242 | shift |
| 243 | elif [ "x$1" = "x--gcstress" ]; then |
| 244 | basic_verify="true" |
| 245 | gc_stress="true" |
| 246 | shift |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 247 | elif [ "x$1" = "x--jvmti-step-stress" ]; then |
| 248 | jvmti_step_stress="true" |
| 249 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 250 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 251 | jvmti_redefine_stress="true" |
| 252 | shift |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 253 | elif [ "x$1" = "x--jvmti-field-stress" ]; then |
| 254 | jvmti_field_stress="true" |
| 255 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 256 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 257 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 258 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 259 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 260 | shift |
| 261 | suspend_timeout="$1" |
| 262 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 263 | elif [ "x$1" = "x--image" ]; then |
| 264 | shift |
| 265 | image="$1" |
| 266 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 267 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 268 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 269 | shift |
| 270 | option="$1" |
| 271 | run_args="${run_args} -Xcompiler-option $option" |
| 272 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 273 | elif [ "x$1" = "x--build-option" ]; then |
| 274 | shift |
| 275 | option="$1" |
| 276 | build_args="${build_args} $option" |
| 277 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 278 | elif [ "x$1" = "x--runtime-option" ]; then |
| 279 | shift |
| 280 | option="$1" |
| 281 | run_args="${run_args} --runtime-option $option" |
| 282 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 283 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 284 | shift |
| 285 | gdb_arg="$1" |
| 286 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 287 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 288 | elif [ "x$1" = "x--debug" ]; then |
| 289 | run_args="${run_args} --debug" |
| 290 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 291 | elif [ "x$1" = "x--debug-wrap-agent" ]; then |
| 292 | run_args="${run_args} --debug-wrap-agent" |
| 293 | shift |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 294 | elif [ "x$1" = "x--with-agent" ]; then |
| 295 | shift |
| 296 | option="$1" |
| 297 | run_args="${run_args} --with-agent $1" |
| 298 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 299 | elif [ "x$1" = "x--debug-agent" ]; then |
| 300 | shift |
| 301 | option="$1" |
| 302 | run_args="${run_args} --debug-agent $1" |
| 303 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 304 | elif [ "x$1" = "x--gdb" ]; then |
| 305 | run_args="${run_args} --gdb" |
| 306 | dev_mode="yes" |
| 307 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 308 | elif [ "x$1" = "x--strace" ]; then |
| 309 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 310 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 311 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 312 | elif [ "x$1" = "x--zygote" ]; then |
| 313 | run_args="${run_args} --zygote" |
| 314 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 315 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 316 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 317 | image_suffix="-interpreter" |
| 318 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 319 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 320 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 321 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 322 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 323 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 324 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 325 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 326 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 327 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 328 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 329 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 330 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 331 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 332 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 333 | elif [ "x$1" = "x--no-optimize" ]; then |
| 334 | run_args="${run_args} --no-optimize" |
| 335 | shift |
| 336 | elif [ "x$1" = "x--no-precise" ]; then |
| 337 | run_args="${run_args} --no-precise" |
| 338 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 339 | elif [ "x$1" = "x--invoke-with" ]; then |
| 340 | shift |
| 341 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 342 | if [ "x$what" = "x" ]; then |
| 343 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 344 | usage="yes" |
| 345 | break |
| 346 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 347 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 348 | shift |
| 349 | elif [ "x$1" = "x--dev" ]; then |
| 350 | run_args="${run_args} --dev" |
| 351 | dev_mode="yes" |
| 352 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 353 | elif [ "x$1" = "x--build-only" ]; then |
| 354 | build_only="yes" |
| 355 | shift |
Alan Leung | 0afa07a | 2017-10-03 16:56:30 -0700 | [diff] [blame] | 356 | elif [ "x$1" = "x--build-with-d8" ]; then |
| 357 | USE_D8="true" |
| 358 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 359 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 360 | USE_JACK="false" |
| 361 | shift |
| 362 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 363 | USE_JACK="true" |
| 364 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 365 | elif [ "x$1" = "x--output-path" ]; then |
| 366 | shift |
| 367 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 368 | if [ "x$tmp_dir" = "x" ]; then |
| 369 | echo "$0 missing argument to --output-path" 1>&2 |
| 370 | usage="yes" |
| 371 | break |
| 372 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 373 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 374 | elif [ "x$1" = "x--android-root" ]; then |
| 375 | shift |
| 376 | if [ "x$1" = "x" ]; then |
| 377 | echo "$0 missing argument to --android-root" 1>&2 |
| 378 | usage="yes" |
| 379 | break |
| 380 | fi |
| 381 | android_root="$1" |
| 382 | run_args="${run_args} --android-root $1" |
| 383 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 384 | elif [ "x$1" = "x--update" ]; then |
| 385 | update_mode="yes" |
| 386 | shift |
| 387 | elif [ "x$1" = "x--help" ]; then |
| 388 | usage="yes" |
| 389 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 390 | elif [ "x$1" = "x--64" ]; then |
| 391 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 392 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 393 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 394 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 395 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 396 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 397 | elif [ "x$1" = "x--stream" ]; then |
| 398 | trace_stream="true" |
| 399 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 400 | elif [ "x$1" = "x--always-clean" ]; then |
| 401 | always_clean="yes" |
| 402 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 403 | elif [ "x$1" = "x--never-clean" ]; then |
| 404 | never_clean="yes" |
| 405 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 406 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 407 | run_args="${run_args} --dex2oat-swap" |
| 408 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 409 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 410 | shift |
| 411 | run_args="${run_args} --instruction-set-features $1" |
| 412 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 413 | elif [ "x$1" = "x--bisection-search" ]; then |
| 414 | bisection_search="yes" |
| 415 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 416 | elif [ "x$1" = "x--vdex" ]; then |
| 417 | run_args="${run_args} --vdex" |
| 418 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 419 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 420 | shift |
| 421 | filter=$1 |
| 422 | run_args="${run_args} --vdex-filter $filter" |
| 423 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 424 | elif [ "x$1" = "x--random-profile" ]; then |
| 425 | run_args="${run_args} --random-profile" |
| 426 | shift |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 427 | elif [ "x$1" = "x--dex2oat-jobs" ]; then |
| 428 | shift |
| 429 | run_args="${run_args} -Xcompiler-option -j$1" |
| 430 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 431 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 432 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 433 | usage="yes" |
| 434 | break |
| 435 | else |
| 436 | break |
| 437 | fi |
| 438 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 439 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 440 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 441 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 442 | # output (fd 2). |
| 443 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 444 | exec {real_stderr}>&2 |
| 445 | else |
| 446 | # In bash before version 4.1 we need to do a manual search for free file |
| 447 | # descriptors. |
| 448 | FD=3 |
| 449 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 450 | real_stderr=$FD |
| 451 | eval "exec ${real_stderr}>&2" |
| 452 | fi |
| 453 | if [ "$quiet" = "yes" ]; then |
| 454 | # Force the default standard output and error to go to /dev/null so we will |
| 455 | # not print them. |
| 456 | exec 1>/dev/null |
| 457 | exec 2>/dev/null |
| 458 | fi |
| 459 | |
| 460 | function err_echo() { |
| 461 | echo "$@" 1>&${real_stderr} |
| 462 | } |
| 463 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 464 | # tmp_dir may be relative, resolve. |
| 465 | # |
| 466 | # Cannot use realpath, as it does not exist on Mac. |
| 467 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 468 | # Cannot use readlink -m, as it does not exist on Mac. |
| 469 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 470 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 471 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 472 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 473 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 474 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 475 | if [ ! "$runtime" = "jvm" ]; then |
| 476 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 477 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 478 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 479 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 480 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 481 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 482 | fi |
| 483 | if [ "$gc_verify" = "true" ]; then |
| 484 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 485 | fi |
| 486 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 487 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 488 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 489 | if [ "$jvmti_redefine_stress" = "true" ]; then |
| 490 | run_args="${run_args} --no-app-image --jvmti-redefine-stress" |
| 491 | fi |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 492 | if [ "$jvmti_step_stress" = "true" ]; then |
| 493 | run_args="${run_args} --no-app-image --jvmti-step-stress" |
| 494 | fi |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 495 | if [ "$jvmti_field_stress" = "true" ]; then |
| 496 | run_args="${run_args} --no-app-image --jvmti-field-stress" |
| 497 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 498 | if [ "$jvmti_trace_stress" = "true" ]; then |
| 499 | run_args="${run_args} --no-app-image --jvmti-trace-stress" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 500 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 501 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 502 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 503 | if [ "$trace_stream" = "true" ]; then |
| 504 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 505 | # the ability to analyze the file and just write to /dev/null. |
| 506 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 507 | # Enable streaming mode. |
| 508 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 509 | else |
| 510 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 511 | fi |
| 512 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 513 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 514 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 515 | fi |
| 516 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 517 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 518 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 519 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 520 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 521 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 522 | if [ "x${suffix64}" = "x64" ]; then |
| 523 | target_arch_name=${grep64bit} |
| 524 | else |
| 525 | target_arch_name=${grep32bit} |
| 526 | fi |
| 527 | } |
| 528 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 529 | function guess_host_arch_name() { |
| 530 | if [ "x${suffix64}" = "x64" ]; then |
| 531 | host_arch_name="x86_64" |
| 532 | else |
| 533 | host_arch_name="x86" |
| 534 | fi |
| 535 | } |
| 536 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 537 | if [ "$target_mode" = "no" ]; then |
| 538 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 539 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 540 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 541 | exit 1; |
| 542 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 543 | fi |
| 544 | fi |
| 545 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 546 | if [ "$have_patchoat" = "no" ]; then |
| 547 | run_args="${run_args} --no-patchoat" |
| 548 | fi |
| 549 | |
| 550 | if [ "$have_dex2oat" = "no" ]; then |
| 551 | run_args="${run_args} --no-dex2oat" |
| 552 | fi |
| 553 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 554 | if [ ! "$runtime" = "jvm" ]; then |
| 555 | run_args="${run_args} --lib $lib" |
| 556 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 557 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 558 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 559 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 560 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 561 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 562 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 563 | else |
| 564 | true # defaults to using target BOOTCLASSPATH |
| 565 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 566 | elif [ "$runtime" = "art" ]; then |
| 567 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 568 | guess_host_arch_name |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 569 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 570 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 571 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 572 | guess_target_arch_name |
Dimitry Ivanov | 49c2c92 | 2017-02-14 11:06:14 -0800 | [diff] [blame] | 573 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}" |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 574 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 575 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 576 | if [ "$relocate" = "yes" ]; then |
| 577 | run_args="${run_args} --relocate" |
| 578 | else |
| 579 | run_args="${run_args} --no-relocate" |
| 580 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 581 | elif [ "$runtime" = "jvm" ]; then |
| 582 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 583 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 584 | fi |
| 585 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 586 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 587 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 588 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 589 | exit 1 |
| 590 | fi |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 591 | run_args="${run_args} --no-image" |
| 592 | fi |
| 593 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 594 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 595 | err_echo "--dev and --update are mutually exclusive" |
| 596 | usage="yes" |
| 597 | fi |
| 598 | |
| 599 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 600 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 601 | usage="yes" |
| 602 | fi |
| 603 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 604 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 605 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 606 | usage="yes" |
| 607 | fi |
| 608 | |
| 609 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 610 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 611 | usage="yes" |
| 612 | fi |
| 613 | |
| 614 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 615 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 616 | usage="yes" |
| 617 | fi |
| 618 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 619 | if [ "$usage" = "no" ]; then |
| 620 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 621 | test_dir=`basename "$oldwd"` |
| 622 | else |
| 623 | test_dir="$1" |
| 624 | fi |
| 625 | |
| 626 | if [ '!' -d "$test_dir" ]; then |
| 627 | td2=`echo ${test_dir}-*` |
| 628 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 629 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 630 | usage="yes" |
| 631 | fi |
| 632 | test_dir="$td2" |
| 633 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 634 | # Shift to get rid of the test name argument. The rest of the arguments |
| 635 | # will get passed to the test run. |
| 636 | shift |
| 637 | fi |
| 638 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 639 | # For building with javac and dx always use Java 7. The dx compiler |
| 640 | # only support byte codes from Java 7 or earlier (class file major |
| 641 | # version 51 or lower). |
| 642 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 643 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 644 | fi |
| 645 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 646 | if [ "$usage" = "yes" ]; then |
| 647 | prog=`basename $prog` |
| 648 | ( |
| 649 | echo "usage:" |
| 650 | echo " $prog --help Print this message." |
| 651 | echo " $prog [options] [test-name] Run test normally." |
| 652 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 653 | "(dumps to stdout)." |
| 654 | echo " $prog --update [options] [test-name] Update mode" \ |
| 655 | "(replaces expected.txt)." |
| 656 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 657 | "current directory." |
| 658 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 659 | echo " -O Run non-debug rather than debug build (off by default)." |
| 660 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 661 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 662 | echo " --runtime-option Pass an option to the runtime." |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 663 | echo " --debug Wait for the default debugger to attach." |
| 664 | echo " --debug-agent <agent-path>" |
| 665 | echo " Wait for the given debugger agent to attach. Currently" |
| 666 | echo " only supported on host." |
| 667 | echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props" |
| 668 | echo " to load the debugger agent specified by --debug-agent." |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 669 | echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 670 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 671 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 672 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 673 | echo " --build-only Build test files only (off by default)." |
Alan Leung | 0afa07a | 2017-10-03 16:56:30 -0700 | [diff] [blame] | 674 | echo " --build-with-d8 Build test files with javac and d8 (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 675 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 676 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 677 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 678 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 679 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 680 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 681 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 682 | echo " Verification is enabled if neither --no-verify" |
| 683 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 684 | echo " --no-optimize Turn off optimization (on by default)." |
| 685 | echo " --no-precise Turn off precise GC (on by default)." |
| 686 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 687 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 688 | echo " other runtime options are ignored." |
| 689 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 690 | echo " --no-patchoat Run as though patchoat was failing." |
| 691 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 692 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 693 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 694 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 695 | echo " --relocate Force the use of relocating in the test, making" |
| 696 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 697 | echo " address before running." |
| 698 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 699 | echo " --image Run the test using a precompiled boot image. (default)" |
| 700 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 701 | echo " --host Use the host-mode virtual machine." |
| 702 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 703 | echo " --dalvik Use Dalvik (off by default)." |
| 704 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 705 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 706 | echo " to find the java compiler and runtime" |
| 707 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 708 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 709 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 710 | echo " --64 Run the test in 64-bit mode" |
| 711 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 712 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 713 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 714 | echo " --gcstress Run with gc stress testing" |
| 715 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 716 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 717 | echo " --jvmti-step-stress Run with jvmti single step stress testing" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 718 | echo " --jvmti-redefine-stress" |
| 719 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 720 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 721 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 722 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 723 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 724 | echo " --instruction-set-features [string]" |
| 725 | echo " Set instruction-set-features for compilation." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 726 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 727 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 728 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 729 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 730 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 731 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 732 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 733 | echo " --dex2oat-jobs Number of dex2oat jobs." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 734 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 735 | exit 1 |
| 736 | fi |
| 737 | |
| 738 | cd "$test_dir" |
| 739 | test_dir=`pwd` |
| 740 | |
| 741 | td_info="${test_dir}/${info}" |
| 742 | td_expected="${test_dir}/${expected}" |
| 743 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 744 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 745 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 746 | exit 1 |
| 747 | fi |
| 748 | |
| 749 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 750 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 751 | exit 1 |
| 752 | fi |
| 753 | |
| 754 | # copy the test to a temp dir and run it |
| 755 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 756 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 757 | |
| 758 | rm -rf "$tmp_dir" |
| 759 | cp -Rp "$test_dir" "$tmp_dir" |
| 760 | cd "$tmp_dir" |
| 761 | |
| 762 | if [ '!' -r "$build" ]; then |
| 763 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 764 | else |
| 765 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 766 | fi |
| 767 | |
| 768 | if [ '!' -r "$run" ]; then |
| 769 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 770 | else |
| 771 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 772 | fi |
| 773 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 774 | if [ '!' -r "$check_cmd" ]; then |
| 775 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 776 | else |
| 777 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 778 | fi |
| 779 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 780 | chmod 755 "$build" |
| 781 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 782 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 783 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 784 | export TEST_NAME=`basename ${test_dir}` |
| 785 | |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 786 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 787 | # Checker when compiled with Optimizing on host. |
| 788 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 789 | if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then |
| 790 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 791 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
| 792 | run_checker="yes" |
| 793 | |
| 794 | if [ "$target_mode" = "no" ]; then |
| 795 | cfg_output_dir="$tmp_dir" |
| 796 | checker_args="--arch=${host_arch_name^^}" |
| 797 | else |
| 798 | cfg_output_dir="$DEX_LOCATION" |
| 799 | checker_args="--arch=${target_arch_name^^}" |
| 800 | fi |
| 801 | |
| 802 | if [ "$debuggable" = "yes" ]; then |
| 803 | checker_args="$checker_args --debuggable" |
| 804 | fi |
| 805 | |
| 806 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
| 807 | -Xcompiler-option -j1" |
| 808 | fi |
| 809 | fi |
| 810 | fi |
| 811 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 812 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 813 | |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 814 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 815 | # ART output to approximately 128MB. This should be more than sufficient |
| 816 | # for any test while still catching cases of runaway output. |
| 817 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 818 | # needed to support a test case rather than resetting the limit in the run |
| 819 | # script for the particular test in question. |
Orion Hodson | bd328d3 | 2017-03-24 11:24:10 +0000 | [diff] [blame] | 820 | if ! ulimit -f 128000; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 821 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 822 | fi |
| 823 | |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 824 | if [[ "$target_mode" == "yes" ]]; then |
| 825 | build_args="$build_args --target" |
| 826 | else |
| 827 | build_args="$build_args --host" |
| 828 | fi |
| 829 | |
| 830 | if [[ "$dev_mode" == "yes" ]]; then |
| 831 | build_args="$build_args --dev" |
| 832 | fi |
| 833 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 834 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 835 | good_build="yes" |
| 836 | good_run="yes" |
Alex Light | 77fee87 | 2017-09-05 14:51:49 -0700 | [diff] [blame] | 837 | export TEST_RUNTIME="${runtime}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 838 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 839 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 840 | build_exit="$?" |
| 841 | echo "build exit status: $build_exit" 1>&2 |
| 842 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 843 | echo "${test_dir}: running..." 1>&2 |
| 844 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 845 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 846 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 847 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 848 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 849 | if [ "$target_mode" = "yes" ]; then |
| 850 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 851 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 852 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 853 | checker_exit="$?" |
| 854 | if [ "$checker_exit" = "0" ]; then |
| 855 | good="yes" |
| 856 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 857 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 858 | else |
| 859 | good="yes" |
| 860 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 861 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 862 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 863 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 864 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 865 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 866 | build_exit="$?" |
| 867 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 868 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 869 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 870 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 871 | if [ "$target_mode" = "yes" ]; then |
| 872 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 873 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 874 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 875 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 876 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 877 | good="yes" |
| 878 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 879 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 880 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 881 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 882 | elif [ "$build_only" = "yes" ]; then |
| 883 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 884 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 885 | build_exit="$?" |
| 886 | if [ "$build_exit" '!=' '0' ]; then |
| 887 | cp "$build_output" "$output" |
| 888 | echo "build exit status: $build_exit" >>"$output" |
| 889 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 890 | if [ "$?" '!=' "0" ]; then |
| 891 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 892 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 893 | fi |
| 894 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 895 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 896 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 897 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 898 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 899 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 900 | build_exit="$?" |
| 901 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 902 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 903 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 904 | run_exit="$?" |
| 905 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 906 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 907 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 908 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 909 | if [ "$target_mode" = "yes" ]; then |
| 910 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 911 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 912 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 913 | checker_exit="$?" |
| 914 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 915 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 916 | good_run="no" |
| 917 | else |
| 918 | good_run="yes" |
| 919 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 920 | else |
| 921 | good_run="yes" |
| 922 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 923 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 924 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 925 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 926 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 927 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 928 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 929 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 930 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 931 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 932 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 933 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 934 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 935 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 936 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 937 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 938 | # output == expected |
| 939 | good="yes" |
| 940 | echo "${test_dir}: succeeded!" 1>&2 |
| 941 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 942 | fi |
| 943 | fi |
| 944 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 945 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 946 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 947 | echo "${test_dir}: FAILED!" |
| 948 | echo ' ' |
| 949 | echo '#################### info' |
| 950 | cat "${td_info}" | sed 's/^/# /g' |
| 951 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 952 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 953 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 954 | if [ "$strace" = "yes" ]; then |
| 955 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 956 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 957 | echo '####################' |
| 958 | fi |
Andreas Gampe | e79ca19 | 2017-07-31 10:30:16 -0700 | [diff] [blame] | 959 | if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then |
| 960 | # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The |
| 961 | # tools used by the given ABI work for both x86 and x86-64. |
| 962 | echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000 |
| 963 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 964 | echo ' ' |
| 965 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 966 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 967 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 968 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 969 | # Attempt bisection only if the test failed. |
| 970 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 971 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 972 | if [ "$run_checker" == "yes" ]; then |
| 973 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 974 | else |
| 975 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 976 | echo "${test_dir}: bisecting..." 1>&2 |
| 977 | cwd=`pwd` |
| 978 | maybe_device_mode="" |
| 979 | raw_cmd="" |
| 980 | if [ "$target_mode" = "yes" ]; then |
| 981 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 982 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 983 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 984 | # for bisection search to correctly retrieve logs from device. |
| 985 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 986 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 987 | maybe_device_mode="--device" |
| 988 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 989 | else |
| 990 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 991 | fi |
| 992 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 993 | $maybe_device_mode \ |
| 994 | --raw-cmd="$raw_cmd" \ |
| 995 | --check-script="$cwd/check" \ |
| 996 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 997 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 998 | --timeout=300 |
| 999 | fi |
| 1000 | fi |
| 1001 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1002 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 1003 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1004 | cd "$oldwd" |
| 1005 | rm -rf "$tmp_dir" |
| 1006 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 1007 | adb shell rm -rf $DEX_LOCATION |
| 1008 | fi |
| 1009 | if [ "$good" = "yes" ]; then |
| 1010 | exit 0 |
| 1011 | fi |
| 1012 | fi |
| 1013 | |
| 1014 | |
| 1015 | ( |
| 1016 | if [ "$always_clean" = "yes" ]; then |
| 1017 | echo "${TEST_NAME} files deleted from host " |
| 1018 | if [ "$target_mode" == "yes" ]; then |
| 1019 | echo "and from target" |
| 1020 | fi |
| 1021 | else |
| 1022 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 1023 | if [ "$target_mode" == "yes" ]; then |
| 1024 | echo "and in ${DEX_LOCATION} on target" |
| 1025 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1026 | fi |
| 1027 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1028 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1029 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1030 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1031 | exit 0 |
| 1032 | else |
| 1033 | exit 1 |
| 1034 | fi |